{% extends 'base.html' %}
{% load static %}

{% block content %}
    <section id="thread-detail" class="container">
        <div class="row">
            <div class="col-12">
                {% for message in messages %}
                    <div class="alert {{ message.tags }} alert-dismissible shadow fade show" role="alert">
                        <h5 class="text-center">{{ message | safe }}</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                {% endfor %}
            </div>
        </div>

        <div class="row justify-content-center">
            <div class="col-12">
                <div class="card-body rounded p-5">

                    <div class="row ps-1 pb-3">
                        <div class="col pages d-flex">
                            <a class="btn dark-blue-background white-text-color" href="{% url 'forum' %}">
                                Forum
                            </a>
                            <img class="dark-blue-img-filter px-2" src="{% static 'icons/arrow-forward.svg' %}" alt="arrow-forward-icon">
                            <form action="{% url 'forum' %}" method="get">
                                {% with thread.category as category %}
                                    <button type="submit" name="th-category" value="{{ category }}"
                                            class="btn primary-background white-text-color">
                                        {{ category }}
                                    </button>
                                {% endwith %}
                            </form>
                        </div>
                    </div>

                    {% if is_paginated %}
                        <ul class=" pagination justify-content-center">
                            {% if page_obj.has_previous %}
                                <li class="page-item">
                                    <a class="page-link" href="?page={{ page_obj.previous_page_number }}">Previous</a>
                                </li>
                            {% endif %}

                            {% for page in page_obj.paginator.page_range %}
                                {% if page_obj.number == page %}
                                    <li class="page-item active">
                                        <a class="page-link current" href="?page={{ page_obj.number }}">{{ page_obj.number }}</a>
                                    </li>
                                {% else %}
                                    <li class="page-item">
                                        <a class="page-link" href="?page={{ page }}">{{ page }}</a>
                                    </li>
                                {% endif %}
                            {% endfor %}

                            {% if page_obj.has_next %}
                                <li class="page-item">
                                    <a class="page-link" href="?page={{ page_obj.next_page_number }}">Next</a>
                                </li>
                            {% endif %}
                        </ul>
                    {% endif %}

                    <div class="row px-3">
                        <div class="col card-title">
                            <div class="row">
                                <div class="col-auto py-2">
                                    {% if edit_title and edit_title == thread.pk %}
                                        {% block edit-th-title %} {% endblock %}
                                    {% else %}
                                        <h2 class="white-text-color ps-3">{{ thread.title }}</h2>
                                    {% endif %}
                                </div>

                                <div class="col align-self-center">
                                    {% if thread.creator.user.account == user %}
                                        <div class="d-flex justify-content-between title-buttons">
                                            <a href="{% url 'edit_title' thread.pk %}?page={{ page_obj.number }}" class="btn px-0">
                                                <img class="white-img-filter" src="{% static 'icons/edit.svg' %}" width="25" alt="edit-icon">
                                            </a>

                                            {% if thread.post_set.all|length_is:"1" %}
                                                <div>
                                                    <button type="button" data-bs-toggle="modal" data-bs-target="#del-thread-{{ thread.pk }}-modal" class="btn px-0">
                                                        <img class="white-img-filter" src="{% static 'icons/close.svg' %}" width="35" alt="close-icon">
                                                    </button>
                                                    {% include 'forum/modals/deleteThreadModal.html' %}
                                                </div>
                                            {% endif %}
                                        </div>

                                    {% else %}
                                        <div class="d-flex justify-content-end p-2">
                                            <a class="btn btn-sm reply-btn d-flex" href="{% url 'new_post' thread.id %}">
                                                <img class="align-bottom primary-img-filter pe-2" src="{% static 'icons/add-black.svg' %}" alt="reply-icon">
                                                <p class="m-0 fs-6 fw-bold">Add answer</p>
                                            </a>
                                        </div>
                                    {% endif %}
                                </div>
                            </div>
                        </div>
                    </div>

                    {% for post in page_obj %}
                        <div class="row post-row py-2 px-3">

                        {% if post.is_thread_post %}
                            <span class="first-post"></span>
                        {% endif %}
                            <div class="col-3 d-flex justify-content-center border background-light py-3 me-2">
                                <div class="d-flex flex-column align-self-center text-center">
                                    <img src="{{ post.author.user.avatar.url }}" class="img-fluid img-thumbnail mb-2"
                                         width="100" alt="avatar">
                                    <strong>{{ post.author }}</strong>
                                    {% if post.author.user.account.is_active %}
                                        <div class="d-flex justify-content-center">
                                            <p class="pe-2">Status:</p>
                                            <img class="{% if post.author.is_online %}on{% else %}off{% endif %}line align-self-baseline"
                                                 src="{% static 'icons/globe.svg' %}" width="22" alt="user-status">
                                        </div>
                                    {% endif %}
                                </div>
                            </div>

                            <div class="col border background-light">
                                <div class="d-flex flex-column justify-content-between h-100">
                                    <div class="d-flex justify-content-between">
                                        <p class="light-grey-text-color pt-2">Posted {{ post.creation_date_str }}, edited {{ post.mod_date_str }}</p>

                                        {% if post.author.user.account == user %}
                                            <div class="buttons">
                                                <a href="{% url 'edit_post' thread.id post.pk %}?page={{ page_obj.number }}" class="btn btn-sm align-baseline px-1">
                                                    <img class="dark-blue-img-filter" src="{% static 'icons/edit.svg' %}" alt="edit-icon">
                                                </a>

                                                {% if not post.is_thread_post %}
                                                    <button type="button" data-bs-toggle="modal" data-bs-target="#del-post-{{ post.pk }}-modal" class="btn btn-sm px-1">
                                                        <img class="dark-blue-img-filter" src="{% static 'icons/close.svg' %}" width="30" alt="close-icon">
                                                    </button>
                                                    {% include 'forum/modals/deletePostModal.html' %}
                                                {% endif %}
                                            </div>
                                        {% endif %}
                                    </div>

                                    {% if post.quote %}
                                        <blockquote class="blockquote mb-0 mt-2 me-2">
                                            <div class="secondary-background">
                                                <img class="start align-self-baseline p-2" src="{% static 'icons/format-quote.svg' %}" alt="quote-icon">
                                                <div class="d-flex fs-6">
                                                    <p class="ps-5 m-0 primary-text-color">
                                                        {{ post.quote.author }}
                                                    </p>
                                                    <p class="m-0 pb-2">&nbsp;wrote:</p>
                                                </div>
                                                <div class="px-5 m-0 fs-6">{{ post.quote.message|safe|linebreaks }}</div>
                                                <div class="d-flex justify-content-end p-2">
                                                    <img src="{% static 'icons/format-quote.svg' %}" alt="quote-icon">
                                                </div>
                                            </div>
                                        </blockquote>
                                    {% endif %}

                                    {% if edit_post and edit_post == post.pk %}
                                        {% block edit-post %} {% endblock %}
                                    {% else %}
                                        <div>{{ post.message|safe }}</div>
                                    {% endif %}

                                    <div class="d-flex justify-content-end p-2">
                                        <a class="btn btn-sm reply-btn d-flex" href="{% url 'reply_post' thread.id post.id %}?page={{ page_obj.number }}">
                                            <img class="align-bottom primary-img-filter pe-2" src="{% static 'icons/reply.svg' %}" alt="reply-icon">
                                            <p class="m-0 fs-6 fw-bold">Reply</p>
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}

                    <!-- Post form -->
                    {% block new-post %} {% endblock %}
                </div>
            </div>
        </div>
    </section>


    <script>
        // If user is not logged, then he can't do anything
        $('.reply-btn').click(function() {
            {% if not user.is_authenticated %}
                alert('You must be logged in to do this.');
                $(this).removeAttr("href");
            {% endif %}
        });

        // Change background of thread message
        $('.post-row span.first-post').siblings().each(function () {
            $(this).removeClass('background-light');
            $(this).siblings().addClass('light-blue-background');
        });

        $('.title-buttons img').hover(function () {
            $(this).toggleClass('white-img-filter');
            $(this).toggleClass('primary-img-filter');
        });

        $('.buttons img').hover(function () {
            $(this).toggleClass('dark-blue-img-filter');
            $(this).toggleClass('primary-img-filter');
        });

        $('section#thread-detail .reply-btn').hover(function() {
            $(this).toggleClass('primary-background');
            $(this).find("img").toggleClass('white-img-filter');
            $(this).find("p").toggleClass('white-text-color');
        });
    </script>

{% endblock %}